unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JvComponentBase, JvHidControllerClass, StdCtrls;

type
  TForm1 = class(TForm)
    JvHidDeviceController1: TJvHidDeviceController;
    ListBox1: TListBox;
    ListBox2: TListBox;
    function JvHidDeviceController1Enumerate(HidDev: TJvHidDevice;
      const Idx: Integer): Boolean;
    procedure JvHidDeviceController1DeviceChange(Sender: TObject);
    procedure JvHidDeviceController1DeviceData(HidDev: TJvHidDevice; ReportID: Byte; const Data: Pointer; Size: Word);
    procedure JvHidDeviceController1DeviceDataError(HidDev: TJvHidDevice;  Error: Cardinal);
    procedure ReadHidData(HidDev: TJvHidDevice; ReportID: Byte; const Data: Pointer; Size: Word);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  Dev: TJvHidDevice;
  Raw:array[0..128] of byte;
  res:boolean;

implementation

{$R *.dfm}


function TForm1.JvHidDeviceController1Enumerate(HidDev: TJvHidDevice; const Idx: Integer): Boolean;
var 
  Dev: TJvHidDevice;
  DevID: Integer;
begin
  //This procedure gets all the HID items:

  // add a descriptive entry to the listbox for the device
  if HidDev.ProductName <> '' then
    DevID := ListBox1.Items.Add(HidDev.ProductName)
  else
    DevID := ListBox1.Items.Add(Format('Device VID=%x PID=%x', [HidDev.Attributes.VendorID, HidDev.Attributes.ProductID]));

  //Retrive the device and assign it to the list
  JvHidDeviceController1.CheckOutByIndex(Dev, Idx);
  ListBox1.Items.Objects[DevID] := Dev;

  //If this device is a joystick then set its OnData property to read its input
  Dev.OnData := ReadHidData;

  //Return true so we can move on to the next device
  Result := True;
end;

{begin
  ListBox1.Items.Append(Format('%s %4X/%4X',[HidDev.ProductName, HidDev.Attributes.VendorID,HidDev.Attributes.ProductID]));
  if (HidDev.Attributes.VendorID=$16C0 ) and (HidDev.Attributes.ProductID=$05DF) then
  begin
    Dev:= HidDev;
    Dev.CheckOut;

    JvHidDeviceController1.CheckOutByIndex(Dev, Idx);
    //Dev.NumInputBuffers := 128;
    //Dev.NumOverlappedBuffers := 128;
    Dev.OnData := ReadHidData;
  end;
  Result:=True;
end;}


procedure TForm1.JvHidDeviceController1DeviceChange(Sender: TObject);
var 
  Count: Integer;
  Dev: TJvHidDevice;
begin
  //This procedure clears all the HID items:

  //Check in all items and remove objects from the list
  for Count:= 0 to ListBox1.Items.Count - 1 do
  begin
    Dev := TJvHidDevice(ListBox1.Items.Objects[Count]);
    JvHidDeviceController1.CheckIn(Dev);
    ListBox1.Items.Objects[Count] := nil;
  end;

  //Clear the listbox
  ListBox1.Items.Clear;

  //Get a list of connected HID items
  JvHidDeviceController1.Enumerate;
end;

procedure TForm1.JvHidDeviceController1DeviceData(HidDev: TJvHidDevice;
  ReportID: Byte; const Data: Pointer; Size: Word);
var
  sR:string;
begin
  SetLength(sR, Size);
  Move(Data^,sR[1], Size);
  ListBox2.Items.Append(sR);
end;

procedure TForm1.JvHidDeviceController1DeviceDataError(HidDev: TJvHidDevice; Error: Cardinal);
begin
  Sleep(10);
end;

procedure TForm1.ReadHidData(HidDev: TJvHidDevice; ReportID: Byte; const Data: Pointer; Size: Word);
var
  sR:string;
begin
  if ReportID = $77 then
  begin
    SetLength(sR, Size);
    Move(Data^, sR[1], Size);
    ListBox2.Items.Append(sR);
  end;
end;

end.
